function Cov_xa=compute_covariance(A,vx,x_grid,SS)

% Index for optimal reset capital

[~,ind_ast]    =min(abs(x_grid-SS.x_ast));

f         = vx;
f(1)      = 0;
f(end)    = 0;

v         = A\f;    

% Apply Lagrange Interpolation for v(x_hat_ast) in the grid

x_1       = x_grid(ind_ast-1);
x_2       = x_grid(ind_ast);
x_3       = x_grid(ind_ast+1);

fx_1      = v(ind_ast-1);
fx_2      = v(ind_ast);
fx_3      = v(ind_ast+1);

M         = (SS.x_ast-x_2)*(SS.x_ast-x_3)/(x_1-x_2)/(x_1-x_3)*fx_1+...
            (SS.x_ast-x_1)*(SS.x_ast-x_3)/(x_2-x_1)/(x_2-x_3)*fx_2+...
            (SS.x_ast-x_1)*(SS.x_ast-x_2)/(x_3-x_1)/(x_3-x_2)*fx_3;
                                                     
Cov_xa    = M/SS.Etau;
               
return

 